#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       chu2doku.py
#
#       Copyright 2007 Jonas Fourquier <jonas.tuxfamily.org>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import re, sys, getopt, os, gzip, ConfigParser

#debugging
#~ import pdb

from config import syntaxe, cleanStr, optionImg     # tableau tuples de conversion de syntaxe, remplacement de chaine, chaine à ajouter au image


def main(argv):
    print ('*** chu2doku ***')

    if '-h' in argv :       usage()
    elif '--help' in argv : usage()
    elif '-a' in argv :     about()
    elif '--about' in argv: about()
    elif len(argv) == 2 :   chu2doku(argv[0],argv[1])
    else :                  usage()


def chu2doku(chu,doku):
    '''Explorer chu, ecrire doku'''
    latestgz = 0 #init

    for file in os.listdir(chu):
        '''explore le dossier chu'''
        dirparent = file #stocker dans un variable le dossier parent (
        nextchu = os.path.join(chu,file)
        nextdoku = os.path.join(doku,cleanName(file))

        if os.path.isdir(nextchu):
            '''Si c'est un dossier, relance la fonction avec'''
            try :   os.mkdir(doku)
            except: pass
            chu2doku(nextchu,nextdoku)
        else:
            try :
                if latestgz < int(file[:-3]) :
                    latestgz = int(file[:-3])
                    filegz = file
            except:
                pass

    print '%s -> %s' %(chu,doku)

    if latestgz :
        '''Si une page chu à été trouvée, création de la page doku'''
        fChu = gzip.open(os.path.join(chu,filegz),'r')
        fDoku = open(doku, 'w+b')

        for chuLine in fChu.readlines() :
            fDoku.write(convSyntaxe(chuLine,os.path.split(doku[0:-4])[-1]))

        fDoku.close()
        fChu.close()

        print " -> OK"
    else:
        print " -> pas de page ici"


def convSyntaxe (line,pagename=''):
    '''Conversion de la syntaxe chu en doku ligne pas ligne'''

    for (chu,doku) in syntaxe:
        # En cas d'erreur dans le coin (voir no de ligne), c'est probablement
        # unechaine regulière incorrect. En Décommentant la ligne suivante
        # chu2doku affiche la chaine utilisé dans le terminal. Ça vous
        # permettra de trouvé celle qui cloche (la dernière avant l'erreur)
        #~ print chu
        doku = doku.replace ('$pagename$', pagename)
        chunc = chu #chaîne non compilée
        chu = re.compile(chu)
        try:
            groups = chu.search(line).groups()
            dico_s = {}
            i = 0
            for s in groups :
                dico_s[str(i)] = s
                i += 1
            replace = doku %dico_s
            line = re.sub(chu,replace,line)
        except :
                pass

    line = linkchu2doku(line)   #Conversion des lien
    line = imgchu2doku(line)    #           des images
    line = bidouille(line)      #divers bidouille pas très académque

    return line



def cleanName(str):
    '''Nettoyer les nom de fichier des pages (%20 -> _, miniscule)'''
    for (strChu, strDoku) in cleanStr :
        str = re.sub(strChu,strDoku,str)
    return '.'.join((str.lower(),'txt'))



def linkchu2doku(str):
    '''fonction pour la transfomation des liens'''
    list4str = []
    for linkText in str.split('['):
        try :
            (link,text) = linkText.split(']')
        except:
            '''Si aucun ] n'est trouvé ajoute telle quel (texte avant lien par ex)'''
            list4str.append(linkText)
        else:
            #~ link = link.replace('//',' ') #les _ servent partout dans ce doku !!! l'tialique dans le lien n'existe pas
            link = link.replace('\//',' ')
            link = link.replace('//',' ')
            if 'http: ' in link:
                link = link.replace('http: ','http://')
            else:
                '''remplace certain caractère pour lien doku propre'''
                link = link.replace('/','-') # les / de chu n'indoque pas une aboressence :/

            itemsLink = link.split('|')
            list4str.append("[[")
            if len(itemsLink) == 1 :
                '''simple lien'''
                list4str.append(itemsLink[0])
            else :
                '''lien + texte alternatif'''
                list4str.extend((itemsLink[1],'|',itemsLink[0]))
            list4str.extend((']]',text))

    return "".join(list4str)


def imgchu2doku(str):
    '''fonction pour la transfomation des images'''
    list4str = []
    for imgText in str.split('(('):
        try :
            (img,text) = imgText.split('))')
        except:
            '''Si aucun )) n'est trouvé ajoute telle quel (texte avant img par ex)'''
            list4str.append(imgText)
        else:
            img = img.replace('\//',' ')
            img = img.replace('//',' ')
            if 'http: ' in img:
                img = img.replace('http: ','http://')
            else:
                '''remplace certain caractère pour lien doku propre'''
                img = img.replace('/',':')


            itemsImg = img.split('|')
            print itemsImg[-1]
            list4str.append("{{")
            if itemsImg[-1] in 'DC':
                '''Image centrée ou a droite ajouter un espace avant'''
                list4str.append(" ")

            list4str.extend((itemsImg[0],optionImg)) #ajout adresse image + optionImg

            if itemsImg[-1] in 'GC':
                '''Image centrée ou a gauche ajouter un espace après'''
                list4str.append(" ")
            list4str.extend(('}}',text))

    return "".join(list4str)


def bidouille (str) :
    '''bidouile très spécifique'''
    #page gestion_dynamique_frequences_cpu des [*] [ ] qui ne sont pas des liens et des <*>
    str = str.replace('[[  * ]]','%%[*]%%')
    str = str.replace('[[ ]]','%%[ ]%%')
    str = str.replace('<  * >','%%<*>%%')
    #italique dans balise code non evaluée
    paire = False
    for codeText in str.split('\'\''):
        if paire:
            if not 'http://' in str:
                #~ if '//' in str: pdb.set_trace()
                str = str.replace('//','_')
            paire = False
        else :
            paire = True




    return str;



# *** USAGE ***********************************************************

def usage():
    '''Aide'''
    print ('''
Usage : chu2doku <dir_chu> <dir_doku> | <option>
  <dir_chu>  : racine des pages de chuwiki (fichiers sources) (.../chuwiki)
  <dir_doku> : racine du dossier ou seront envoyer les pages dokuwiki créer (fichiers de sortie)
  <option>   : -h | --help  : l'aide (ce message)
               -a | --about : a propos (site web, licence)

Exemple de conversion sous GNU/Linux:
  $ chu2doku.py /var/www/chuwiki/pages /var/www/dokuwiki/data/pages #Convertir les pages
  $ cp -R /var/www/chuwiki/images/* /var/www/dokuwiki/data/media #Copier les images
''')

def about():
    '''apropos'''
    print ('''
#       chu2doku.py
#
#       Copyright 2007 Jonas Fourquier <jonas.tuxfamily.org>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
''')

main(sys.argv[1:])
exit(2)
